/**
 * oscP5sendreceive by andreas schlegel
 * oscP5 website at http://www.sojamo.de/oscP5
 */
import oscP5.*;
import netP5.*;


class OscP5receive {
  //wiimote buttons
  float b, a, minus, plus, up, down, left, right, home, one, two;
  //wiimote accelerometers
  float rollover, pitch, accX;

  OscP5receive() {
    OscP5 oscP5;
    oscP5 = new OscP5(this,47110);
  }



  /* start oscP5, listening for incoming messages at port 47110 */


  /* myRemoteLocation is a NetAddress. a NetAddress takes 2 parameters,
   * an ip address and a port number. myRemoteLocation is used as parameter in
   * oscP5.send() when sending osc packets to another computer, device, 
   * application. usage see below. for testing purposes the listening port
   * and the port of the remote location address are the same, hence you will
   * send messages back to this sketch.
   */


  /* incoming osc message are forwarded to the oscEvent method. */
  void oscEvent(OscMessage theOscMessage) {
    /* print the address pattern and the typetag of the received OscMessage */
    //print("### received an osc message.");
    //print(" addrpattern: "+theOscMessage.addrPattern());
    if(theOscMessage.checkAddrPattern("/buttons")) {
      b = theOscMessage.get(0).intValue();
      a = theOscMessage.get(1).intValue();
      plus = theOscMessage.get(2).intValue();
      minus = theOscMessage.get(3).intValue();
      up = theOscMessage.get(4).intValue();     
      down = theOscMessage.get(5).intValue();
      left = theOscMessage.get(6).intValue();
      right = theOscMessage.get(7).intValue(); 
      home = theOscMessage.get(8).intValue();
      one = theOscMessage.get(9).intValue();
      two = theOscMessage.get(10).intValue();  
      //print("B:"+b +" A:"+a +" plus:"+plus + " minus:"+minus +" up:"+up +" down:"+down +" left:"+left +" right:"+right +" home:"+home);
    }
    if(theOscMessage.checkAddrPattern("/accelerometers")) {
      pitch = theOscMessage.get(0).floatValue();
      //rollover = theOscMessage.get(1).floatValue();
      accX = theOscMessage.get(2).floatValue();
      if(accX<=0)  //cancel out negative accelerations (optional of course)
        accX=0;
    }
  }
  float[] getWii() {
    /*0**1**2*****3******4******5***6*****7****8*******9*****10***11***12*/
    float[] wiiParam = {
      b, a, pitch, plus, minus, up, down, left, right, home, one, two, accX
    };
    return wiiParam;
  }
}

