import fullscreen.*;
SoftFullScreen _fullScreen;

int      anzahl = 7;  //initial amount of symbols
int      randX = 50;
int      randY = 50;
float    xStep, yStep;
float    mX, mY, param2;
int[]    permutationsIndexList = new int[2*anzahl-2];
int      version=1;

//flags for the wii-mote
boolean  flag = false;
boolean  flag2 = true;
boolean  flag3 = true;
boolean flag4 = true;
boolean flag5 = true;
boolean flag5_1 = true;
boolean flag5_2 = true;
boolean flag5_3 = true;

//animation speed (for color x-fading)
int      animSpeed=50;
int      animTime=2000;
float    time;
int       curTime=0;

int[]    animSpeed2 = new int[anzahl];
int      animTime2 = 1000;
float[]    time2 = new float[anzahl];
int[]   curTime2 = new int[anzahl];
float    r,g,b,old_r, old_b, old_g;
float    symbolDiameter;
int colorFlowSpeed = 1;



Symbol   symbol;
OscP5receive osc;

void setup()
{
  //FULLSCREEN
  _fullScreen = new SoftFullScreen(this);
  _fullScreen.enter();    
  size(600,600);
  smooth();
  symbolDiameter  = (height/anzahl)-10; 
  permutationsIndexList = getIndexList(anzahl);

  xStep = (screen.width - 2 * randX) / (float)(anzahl-1);
  yStep = (screen.height - 2 * randY) / (float)(anzahl-1);

  mX = 0;
  mY = 0;
  symbol = new Symbol();  //initialize my symbol
  osc = new OscP5receive(); //initialize OSC (open sound controll)

  //each symbol has its animation time
  for(int i=0; i<anzahl; i++) {
    curTime2[i] = 0;
    animSpeed2[i] = colorFlowSpeed+i;
  }
}

void draw()
{ //inner-circle rotation effect
  if(osc.getWii()[10] == 1)  //wiimote-One button 
    mY+=0.25;

  //back ground color fading effect
  backGroundColor();

  //increase/decrease amount of symbols
  multiply();

  noStroke();

  //rotation symbol
  if(osc.getWii()[7]==1)  //wiimote-Left button
    mX+=0.1;
  else if(osc.getWii()[8]==1)  //wiimote-Right  button
    mX-=0.1;  
  pushMatrix();
  translate(randX,randY);
  int j = 0;

  //start of the symbol drawing
  for(int y=0; y<anzahl; y++)
  {     
    pushMatrix();
    for(int x=0; x<anzahl;x++)
    { //click through symmetry versions using wiimote-One button
      if(osc.getWii()[11] == 1 && flag3) {
        version++;
        version%=5;
        flag3 = false;
        println(version);
      }
      if(flag5) {
        curTime2[x] += animSpeed2[x];
        time2[x] = curTime2[x] * 1.0 / animTime2;
        if(curTime2[x] >= animTime2)
          curTime2[x] = 0;
      }
      if(osc.getWii()[11] == 0)
        flag3 = true;

      //select symmetry preset 
      param2 = selectVersion(x,y, version);     

      //wiimote-Home button turns color flow on/off
      if(osc.getWii()[9] == 1 && flag5_1) {  //wiimote-home  button
        flag5= !flag5;
        flag5_1 = false;
      }
      if(osc.getWii()[9] == 0) {
        flag5_1= true;
      }
      if((osc.getWii()[9]== 1 && osc.getWii()[3]== 1) && flag5_3) {
        flag5= true;
        flag5_3 = false;
        colorFlowSpeed++;
      }
      if((osc.getWii()[9]== 1 && osc.getWii()[4]== 1) && flag5_2) {
        flag5= true;
        flag5_2 = false;
        colorFlowSpeed--;
        if(colorFlowSpeed<=1)
          colorFlowSpeed=1;
      }
      if(osc.getWii()[4]== 0)
        flag5_2 = true;
      if(osc.getWii()[3]== 0)
        flag5_3 = true;

      symbol.drawPermutationObj(permutationsIndexList[x+j], symbolDiameter, param2, mY, anzahl, osc.getWii(),2000, time2[y]); //time: 0..1.0
      translate(xStep,0.0f);
    }
    j++;
    popMatrix();
    translate(0.0f,yStep);
  }
  popMatrix();
}


int[] getIndexList(int a) {
  int aIndex = (2*a)-1;
  int[] lookup = new int[aIndex];
  for(int i=0; i<a; i++) {
    lookup[i] = i;
    lookup[aIndex-1-i] = i;
  }
  return lookup;
}
//multiply symbols
void multiply() {
  if((osc.getWii()[9]==0 && osc.getWii()[3]==1) && flag) {  //wiimote-Plus button
    anzahl=anzahl+1;
    animSpeed2 = new int[anzahl];
    time2 = new float[anzahl];
    curTime2 = new int[anzahl];
    for(int i=0; i<anzahl; i++) {
      curTime2[i] = (int)(animTime2*0.5);
      animSpeed2[i] = colorFlowSpeed+i;
    }   
    flag = false;  //just one impluse even when stayed pressed
  }
  else if((osc.getWii()[9]==0 && osc.getWii()[4]==1) && flag) { //wiimote-Minus button
    anzahl=anzahl-1;
    if(anzahl<=1)
      anzahl = 1;
    animSpeed2 = new int[anzahl];
    time2 = new float[anzahl];
    curTime2 = new int[anzahl];
    for(int i=0; i<anzahl; i++) {
      curTime2[i] = (int)(animTime2*0.5);
      animSpeed2[i] = colorFlowSpeed+i;
    }    
    flag = false;  //just one impluse even when stayed pressed
  }
  else if(osc.getWii()[3]==0 || osc.getWii()[4]==0 ) {
    flag = true;  //when released, reset flag
  }

  permutationsIndexList = new int[2*anzahl-2];
  permutationsIndexList = getIndexList(anzahl);
  xStep = (width - 2 * randX) / (float)(anzahl-1);
  yStep = (height - 2 * randY) / (float)(anzahl-1);
}

void backGroundColor() {
  if(osc.getWii()[1] == 1 && flag2) {
    curTime = 0;  //reset time ramp
    //save old colors
    old_r=r;
    old_g=g;
    old_b=b;

    flag2 = false;
    float c1 = osc.getWii()[2];  //get 1st color parameter from wiimote-A
    float c2 = map( osc.getWii()[2],0,255,255,0);  //inverted 1st parameter
    int ran = int(random(2));  //select between 2  colors models
    int ran2 = int(random(3));  //select between 3 color-model 'saturations'

    switch(ran)
    {
    case 0:
      r = c2;
      g = ran2*50;
      b = ran2*50;    
      break;

    case 1:
      r = ran2*50;
      g = ran2*50;
      b = c1;      
      break;
    }
  }
  if(osc.getWii()[1] ==0) {
    flag2 = true;
  }
  curTime += animSpeed;
  time = curTime * 1.0 / animTime;  //time ramp
  if(curTime >= animTime)
    curTime = animTime;   //when max. time reached, stop   

  //new color = old color + ((difference) * time ramp)
  float new_r = old_r+((r-old_r)*time);
  float new_g = old_g+((g-old_g)*time);
  float new_b = old_b+((b-old_b)*time);
  background(new_r,new_g,new_b);
}


//symmetry presets
float selectVersion(int x, int y, int v) {

  switch(v)
  {
  case 0:
    return mX*2*(x+y+1)*PI/anzahl;   
  case 1:
    return mX*2*(x+1)*PI/anzahl; 
  case 2:
    return mX*2*(y+1)*PI/anzahl;
  case 3:
    return mX*2*(-x-y+1)*PI/anzahl;
  case 4:
    return mX*2*(-x+1)*PI/anzahl;
  case 5: 
    return mX*2*(-y+1)*PI/(anzahl*1.0);
  default:
    return 0;
  }
}

